function getFilesList(link)
{
    $(".list-group").empty();
    $('#alertMessage').hide();

    var request = new XMLHttpRequest();


    request.open('POST', "/api/export", true);
    let sessionId = localStorage.getItem('sessionId');
    var data = {
        "accessToken" : document.getElementById('access_token').value,
        "folder": document.getElementById('folder').value,
        "link": link,
        "sessionId": sessionId
    };

    request.setRequestHeader("content-type","application/json");
    request.send(JSON.stringify(data));
    request.onreadystatechange = function() {

        if (request.readyState == 4 && (request.status == 200 || request.status == 0)) {
            var result = JSON.parse(request.responseText);
            if (result.$previous) {
                addNextPrevisous(result.$previous, "Previous");
            }
            if (result.items) {
                result.items.forEach(item => {
                    if (item.key) {
                        addFile(item.key, item.downloadUrl, document.getElementById('access_token').value);
                    }
                });
            }
            if (result.$next) {
                addNextPrevisous(result.$next, "Next");
            }
            loadCurlCommands();
        } else if (request.readyState == 4 ) {
            var result = JSON.parse(request.responseText);
            $('#alertMessageContent').text(result.message);
            $('#alertMessage').show();
            loadCurlCommands();
        }
    };
}

function addFile(key, url, accessToken){
    let item = document.createElement("a");
    item.setAttribute('href', '/api/download?filename=' + key + '&path=' + url + '&token=' + accessToken);
    item.setAttribute('class', 'list-group-item list-group-item-action');
    item.setAttribute('target', "_blank");
    item.textContent = key;
    $(".list-group").append(item);
}


function addNextPrevisous(link, text) {
    let item = document.createElement("button");
    item.setAttribute('type', 'button');
    item.setAttribute('class', 'list-group-item list-group-item-secondary');
    item.setAttribute('onclick', "getFilesList('"+ link + "');");
    item.textContent = text;
    $(".list-group").append(item);
}
