function generateAccessToken(refresh)
{
    $('#alertMessage').hide();
    $('#successMessage').hide();
    var request = new XMLHttpRequest();

    var path;

    if (refresh) {
        path = '/api/refreshAccessToken';
    } else {
        path = '/api/initiateAccessToken';
    }
    console.log(path);
    request.open('POST', path, true);
    let sessionId = localStorage.getItem('sessionId');
    var data = {
        "access_code_or_refresh_token" : document.getElementById('access_code_or_refresh_token').value,
        "sessionId": sessionId
    };

    request.setRequestHeader("content-type","application/json");
    request.send(JSON.stringify(data));
    request.onreadystatechange = function() {

        if (request.readyState == 4 && (request.status == 200 || request.status == 0)) {
            var result = JSON.parse(request.responseText);
            $('#successMessageContent').html("access_token : " + result.access_token
                + "<br />scope : " + result.scope
                + "<br />token_type : " + result.token_type
                + "<br />expires_in : " + result.expires_in
                + "<br />refresh_token : " + result.refresh_token
                + "<br />refresh_token_expires_in : " + result.refresh_token_expires_in
                + "<br />customer_id : " + result.customerId)

            localStorage.setItem('token', JSON.stringify({ refresh_token: result.refresh_token }));
            if (refresh) {
                document.getElementById('access_code_or_refresh_token').value = result.refresh_token;
            }
            $('#successMessage').show();
            loadCurlCommands();
        } else if (request.readyState == 4 ) {
            var result = JSON.parse(request.responseText);
            $('#alertMessageContent').text(result.message);
            $('#alertMessage').show();
            loadCurlCommands();
        }
    };
}



function deleteRefreshToken()
{
    $('#alertMessage').hide();
    $('#successMessage').hide();
    var request = new XMLHttpRequest();

    var path;

    
    path = '/api/deleteRefreshToken';

    console.log(path);
    request.open('POST', path, true);
    let sessionId = localStorage.getItem('sessionId');
    var data = {
        "access_code_or_refresh_token" : document.getElementById('access_code_or_refresh_token').value,
        "sessionId": sessionId
    };

    request.setRequestHeader("content-type","application/json");
    request.send(JSON.stringify(data));
    request.onreadystatechange = function() {

        if (request.readyState == 4 && (request.status == 200 || request.status == 0)) {
            var result = JSON.parse(request.responseText);
            
            $('#successMessageContent').html("Refresh token successfully deleted");
            localStorage.setItem('token', "");
            if (refresh) {
                document.getElementById('access_code_or_refresh_token').value = "";
            }
            $('#successMessage').show();
            loadCurlCommands();
        } else if (request.readyState == 4 ) {
            var result = JSON.parse(request.responseText);
            $('#alertMessageContent').text(result.message);
            $('#alertMessage').show();
            loadCurlCommands();
        }
    };
}

function loadToken(refresh) {

    if (!refresh) {
        return;
    }
    let data = JSON.parse(localStorage.getItem('token'));

    if (data && data.refresh_token) {

        document.getElementById('access_code_or_refresh_token').value = data.refresh_token;
        let request = new XMLHttpRequest();

        request.open('POST', '/api/decodeToken', true);
        let content = {
            "token" : data.refresh_token
        };

        request.setRequestHeader("content-type","application/json");
        request.send(JSON.stringify(content));
        request.onreadystatechange = function() {

            if (request.readyState == 4 && (request.status == 200 || request.status == 0)) {
                let result = JSON.parse(request.responseText);
                console.log(request.responseText);
                let content = "<b>Current Refresh token details</b> <br />Configuration : " + result.url + "<br /> Scope : " + result.scopes;

                $('#tokenDetailsContent').html(content);

                $('#tokenDetails').show();
            }
        };
    }
}